import EsAmap from './src/amap.vue'
import EsMarker from './src/marker.vue'
import EsPolyline from './src/polyline.vue'
import EsPolygon from './src/polygon.vue'
import EsTile from './src/tile.vue'
import EsScaleBar from './src/scale.vue'
import EsMarkerClusterer from './src/markerClusterer.vue'

import { initAMapApiLoader } from './src/services/injected-amap-api-instance'

const base = {
	EsAmap,
	EsMarker,
	EsMarkerClusterer,
	EsPolyline,
	EsTile,
	EsPolygon,
	EsScaleBar,
}

const install = function(Vue) {
	if (install.installed) return

	Object.keys(base).forEach(key => {
		Vue.component(key, base[key])
	})
}

if (typeof window !== 'undefined' && window.Vue) {
	install(window.Vue)
}

const API = {
	version: process.env.VERSION, // eslint-disable-line no-undef
	install,
	...base,
}

export default API

export { base, initAMapApiLoader }
